//------------------------------------------------------------------
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Yellow
#property indicator_color2 LimeGreen
#property indicator_color3 LimeGreen
#property indicator_color4 PaleVioletRed
#property indicator_color5 PaleVioletRed
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2


extern string             TimeFrame       = "Current time frame";
extern int                MAPeriod        = 12;
extern ENUM_MA_METHOD     MAMethod        = MODE_LWMA;
extern int                MAShift         = 0;
extern ENUM_APPLIED_PRICE MAPrice         = 0;
input bool                alertsOn        = true;              // Alerts on true/false?
input bool                alertsOnCurrent = false;             // Alerts on open bar true/false?
input bool                alertsMessage   = true;              // Alerts popup message true/false?
input bool                alertsSound     = false;             // Alerts sound true/false?
input bool                alertsEmail     = false;             // Alerts email true/false?
input bool                alertsPushNotif = false;             // Alerts notification true/false?
input string              soundfile       = "alert2.wav";      // Sound file for alerts

//
//
//
//
//

double ma[];
double maUa[];
double maUb[];
double maDa[];
double maDb[];
double slope[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,ma);
   SetIndexBuffer(1,maUa);
   SetIndexBuffer(2,maUb);
   SetIndexBuffer(3,maDa);
   SetIndexBuffer(4,maDb);
   SetIndexBuffer(5,slope);

         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
         
   for (int i=0; i<5; i++) SetIndexShift(i,MAShift*timeFrame/Period());
   return(0);
}

//
//
//
//
//

int start()
{ 
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ma[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
      
   if (calculateValue || timeFrame == Period())
   {
      if (slope[limit]== 1) CleanPoint(limit,maUa,maUb);
      if (slope[limit]==-1) CleanPoint(limit,maDa,maDb);
      for(int i = limit; i >= 0; i--)
      {  
         ma[i]   = iMA(NULL,0,MAPeriod,0,MAMethod,MAPrice,i);   
         maUa[i] = EMPTY_VALUE;
         maUb[i] = EMPTY_VALUE;
         maDa[i] = EMPTY_VALUE;
         maDb[i] = EMPTY_VALUE;
      
         //
         //
         //
         //
         //

         slope[i] = 0;            
            if (ma[i] > ma[i+1]) slope[i] =  1;
            if (ma[i] < ma[i+1]) slope[i] = -1;
            if (slope[i] ==  1)  PlotPoint(i,maUa,maUb,ma);
            if (slope[i] == -1)  PlotPoint(i,maDa,maDb,ma);
      }
      if (alertsOn)
      {
        int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
        if (slope[whichBar] != slope[whichBar+1])
        if (slope[whichBar] == 1)
              doAlert(" up");
        else  doAlert(" down");       
      }  
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (slope[limit]== 1) CleanPoint(limit,maUa,maUb);
   if (slope[limit]==-1) CleanPoint(limit,maDa,maDb);
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         ma[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MAPeriod,MAMethod,0,MAPrice,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPushNotif,soundfile,0,y);
         slope[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MAPeriod,MAMethod,0,MAPrice,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPushNotif,soundfile,5,y);
         maUa[i]  = EMPTY_VALUE;
         maUb[i]  = EMPTY_VALUE;
         maDa[i]  = EMPTY_VALUE;
         maDb[i]  = EMPTY_VALUE;
            if (slope[i] ==  1)  PlotPoint(i,maUa,maUb,ma);
            if (slope[i] == -1)  PlotPoint(i,maDa,maDb,ma);
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message = stringToTimeFrame(_Period)+" "+_Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" Ma color "+doWhat;
             if (alertsMessage)   Alert(message);
             if (alertsPushNotif) SendNotification(message);
             if (alertsEmail)     SendMail(_Symbol+" Ma color ",message);
             if (alertsSound)     PlaySound(soundfile);
      }
}


